; #########################################################################

.const

CreateBstr PROTO :DWORD
CreateSingleBstr PROTO :DWORD
UtoA	PROTO :DWORD
AtoU	PROTO :DWORD	

	BSTR MACRO arg
		invoke CreateBstr,SADR(arg)
		EXITM<eax>
	ENDM

	
   .data	
bstr_array dd 50 dup (0)
buffer db MAX_PATH dup (0)
ubuffer dw MAX_PATH dup (0)
    .code

;################################################################
UtoA PROC  pChain:DWORD 
	invoke WideCharToMultiByte,CP_ACP,NULL,pChain,\
		-1,addr buffer,LENGTHOF buffer,NULL,NULL
	.if eax != 0
		mov edx,eax
		lea eax,buffer
	.endif		  		
         ret
UtoA endp

;################################################################

AtoU PROC  pChain:DWORD 
	invoke MultiByteToWideChar,CP_ACP,NULL,pChain,\
		-1,addr ubuffer,LENGTHOF ubuffer
	.if eax != 0
		mov edx,eax
		lea eax,ubuffer
	.endif		  
         ret
AtoU endp


;################################################################
CreateSingleBstr PROC  pChain:DWORD 
			Local  retour:DWORD
			Local   phrase[MAX_PATH]:WORD 
	invoke MultiByteToWideChar,CP_ACP,NULL,pChain,\
		-1,addr phrase,LENGTHOF phrase  
	invoke SysAllocString,addr phrase
	mov retour,eax	

 FindeCreateSingleBstr:
         mov eax,retour
         ret
CreateSingleBstr endp


;################################################################
;use bstr_array in data
CreateBstr PROC  pChain:DWORD  
			Local  retour:DWORD
			Local   phrase[MAX_PATH]:WORD 
	mov eax,pChain
	invoke MultiByteToWideChar,CP_ACP,NULL,pChain,\
		-1,addr phrase,LENGTHOF phrase  
	invoke SysAllocString,addr phrase
	mov retour,eax	
	.if eax == 0
		;invoke MessageBox,NULL,SADR("FAILED"),SADR("MultiByteToWideChar"),MB_OK
		jmp FindeCreateBstr
	.endif
	;---------------- save pointer in an array BSTR -----------------
	lea edx,bstr_array
	.LISTALL
	mov ecx,LENGTHOF bstr_array
	.NOLIST
	@@:
	.if dword ptr [edx] == 0
		mov [edx],eax
	.else
		dec ecx
		.if ecx != 0	;not the end of array
			add edx,4
			jmp @B
		.else
			;failed to save bstr pointer			
			;invoke MessageBox,NULL,SADR("BSTR array too small"),SADR("ERREUR"),MB_OK
			invoke SysFreeString,retour
			mov retour,0			
		.endif
	.endif
 FindeCreateBstr:
         mov eax,retour
         ret
CreateBstr endp

;################################################################
;use bstr_array in data
FreeBSTR PROC uses esi
			Local count:DWORD
			Local  retour:DWORD
         mov retour,1
	mov ecx,LENGTHOF bstr_array
	mov count,ecx
	lea esi,bstr_array
	@@:
	.if dword ptr [esi] != 0
		mov edx,dword ptr [esi]
		invoke SysFreeString,edx
		mov dword ptr [esi],0
		add esi,4
		dec count
		jnz @B
	.endif
 FindeFreeBSTR:
         mov eax,retour
         ret
FreeBSTR endp


; #########################################################################
	 
